Summary: GNU Emacs
Name: emacs
Version: 20.3
Release: 2
Copyright: GPL
Group: Applications/Editors/Emacs
Source0: ftp://ftp.gnu.org/pub/gnu/emacs-20.3.tar.gz
Source1: ftp://ftp.gnu.org/pub/gnu/leim-20.3.tar.gz
Source2: emacs.wmconfig
Packager: jvromans@squirrel.nl
BuildRoot: /tmp/em-root

%description
Emacs is the extensible, customizable, self-documenting real-time
display editor.  Emacs has special code editing modes, a scripting
language (elisp), and comes with many packages for doing mail,
news, and more, all in your editor.

This package includes the libraries necessary to run the emacs editor -
the actual program can be found in either the emacs-nox or emacs-X11
packages, depending on whether you use X Windows or not.

Important: This version of Emacs is MULE enabled, and includes the
leim package for extended input mehods.

%ChangeLog
Version 1 of this distribution missed the LEIM files. This has been
corrected. 

%package el
Summary: .el source files -- not necessary to run Emacs
Group: Applications/Editors/Emacs

%description el
This package contains the emacs-lisp sources for many of the
elisp programs included with the main emacs package.  You do
not need this package unless you want to modify these packages,
or see some elisp examples.

%ifnarch alpha
%package nox
Summary: emacs-nox -- no X libraries required
Group: Applications/Editors/Emacs
Requires: emacs

%description nox
This package contains an emacs binary built without support for
X Windows.  While the emacs binary in the main emacs package will
work fine outside of X Windows (on the console, for instance),
the one in this package has a smaller memory image.
%endif

%package X11
Summary: emacs-X11 -- emacs with X Windows libraries
Group: Applications/Editors/Emacs
Requires: emacs

%description X11
This package contains an emacs binary built with support for X
Windows. It will still work fine outside of X Windows (on the console,
for instance) but supports the mouse and GUI elements when used inside
of X Windows.

%prep
%setup -q
%setup -T -D -b 1

%build
ARCHDIR=${RPM_ARCH}-redhat-linux
HOSTTYPE=${RPM_ARCH}-redhat-linux
PUREDEF=""
XPUREDEF=""

%ifnarch alpha
CFLAGS="$RPM_OPT_FLAGS $PUREDEF" LDFLAGS=-s ./configure --prefix=/usr --libexecdir=/usr/lib --with-x=no --sharedstatedir=/var $HOSTTYPE
make
cp src/emacs emacs-nox

make clean
%endif

CFLAGS="$RPM_OPT_FLAGS $XPUREDEF" LDFLAGS=-s ./configure --prefix=/usr --with-x-toolkit --libexecdir=/usr/lib --sharedstatedir=/var $ARCHDIR
make 

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr
ARCHDIR=${RPM_ARCH}-redhat-linux

make libexecdir=$RPM_BUILD_ROOT/usr/lib prefix=$RPM_BUILD_ROOT/usr sharedstatedir=$RPM_BUILD_ROOT/var install
cd leim
make libexecdir=$RPM_BUILD_ROOT/usr/lib prefix=$RPM_BUILD_ROOT/usr sharedstatedir=$RPM_BUILD_ROOT/var install
cd ..
rm -f $RPM_BUILD_ROOT/usr/info/dir
gzip -9nf $RPM_BUILD_ROOT/usr/info/*

%ifnarch alpha
install -m755 emacs-nox $RPM_BUILD_ROOT/usr/bin
%endif

# For some reason, when emacs is stripped on the Alpha, it dumps core
# Lucky for us it started doing this on the Intel as well. Yeah.
#strip $RPM_BUILD_ROOT/usr/bin/* ||:
for I in cvtmail digest-doc emacsserver fakemail hexl movemail profile \
	sorted-doc timer wakeup yow; do
	strip $RPM_BUILD_ROOT/usr/lib/emacs/$RPM_PACKAGE_VERSION/$ARCHDIR/$I||:
done

chown root.mail $RPM_BUILD_ROOT/usr/lib/emacs/$RPM_PACKAGE_VERSION/$ARCHDIR/movemail
chmod 2755 $RPM_BUILD_ROOT/usr/lib/emacs/$RPM_PACKAGE_VERSION/$ARCHDIR/movemail

mkdir -p $RPM_BUILD_ROOT/usr/lib/emacs/site-lisp

mv $RPM_BUILD_ROOT/usr/man/man1/ctags.1 $RPM_BUILD_ROOT/usr/man/man1/gctags.1
mv $RPM_BUILD_ROOT/usr/bin/ctags $RPM_BUILD_ROOT/usr/bin/gctags

# wmconfig file
mkdir -p $RPM_BUILD_ROOT/etc/X11/wmconfig
install -m 0644 $RPM_SOURCE_DIR/emacs.wmconfig $RPM_BUILD_ROOT/etc/X11/wmconfig/emacs


#
# create file lists
#

find $RPM_BUILD_ROOT/usr/share/emacs/%{PACKAGE_VERSION}/lisp \
  -name '*.elc' -print | sed "s^$RPM_BUILD_ROOT^^" > elc-filelist
find $RPM_BUILD_ROOT/usr/share/emacs/%{PACKAGE_VERSION}/leim \
  -name '*.elc' -print | sed "s^$RPM_BUILD_ROOT^^" >> elc-filelist
find $RPM_BUILD_ROOT/usr/share/emacs/%{PACKAGE_VERSION}/leim/leim-list.el \
  -print | sed "s^$RPM_BUILD_ROOT^^" >> elc-filelist

#
# be sure to exclude some files which are needed in core package
#
find $RPM_BUILD_ROOT/usr/share/emacs/%{PACKAGE_VERSION}/lisp \
  -name '*.el' -print | sed "s^$RPM_BUILD_ROOT^^" |\
  grep -v "international\/latin-[0-9]*.el" > el-filelist
find $RPM_BUILD_ROOT/usr/share/emacs/%{PACKAGE_VERSION}/leim \
  -name '*.el' -print | sed "s^$RPM_BUILD_ROOT^^" |\
  grep -v "leim/leim-list.el" >> el-filelist

%post

%preun
 
%clean
rm -rf $RPM_BUILD_ROOT

%files -f elc-filelist
%doc etc/NEWS BUGS README etc/FAQ
/usr/bin/b2m
/usr/bin/gctags
/usr/bin/emacsclient
/usr/bin/etags
/usr/bin/rcs-checkin
/usr/man/*/*
/usr/info/*
#%dir /var/lock/emacs

%dir /usr/lib/emacs
     /usr/lib/emacs/%{PACKAGE_VERSION}
%dir /usr/lib/emacs/site-lisp

%dir /usr/share/emacs/site-lisp
%dir /usr/share/emacs/%{PACKAGE_VERSION}
%dir /usr/share/emacs/%{PACKAGE_VERSION}/site-lisp
%dir /usr/share/emacs/%{PACKAGE_VERSION}/leim
%dir /usr/share/emacs/%{PACKAGE_VERSION}/lisp
%dir /usr/share/emacs/%{PACKAGE_VERSION}/lisp/term
     /usr/share/emacs/%{PACKAGE_VERSION}/etc

# handled by dynamically generated file lists
#/usr/share/emacs/%{PACKAGE_VERSION}/lisp/*.elc
#/usr/share/emacs/%{PACKAGE_VERSION}/lisp/*/*.elc
#/usr/share/emacs/%{PACKAGE_VERSION}/lisp/*.elc
#/usr/share/emacs/20.2/lisp/mail/*.elc

/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/README
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/AT386.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/bobcat.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/internal.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/keyswap.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/lk201.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/vt102.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/vt125.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/vt201.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/vt220.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/vt240.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/vt300.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/vt320.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/vt400.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term/vt420.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/COPYING
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/forms-d2.dat
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/README
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/mail/blessmail.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/forms-d2.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/forms-pass.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/loaddefs.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/loadup.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/patcomp.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/paths.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/mail/sc.el
#/usr/share/emacs/%{PACKAGE_VERSION}/lisp/term-nasty.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/version.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/subdirs.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/international/latin-1.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/international/latin-2.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/international/latin-3.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/international/latin-4.el
/usr/share/emacs/%{PACKAGE_VERSION}/lisp/international/latin-5.el

%files el -f el-filelist
# handled by dynamically generated file lists
#/usr/share/emacs/%{PACKAGE_VERSION}/lisp/*.el
#/usr/share/emacs/%{PACKAGE_VERSION}/lisp/*/*.el

%ifnarch alpha
%files nox
/usr/bin/emacs-nox
%endif

%files X11
/usr/bin/emacs
%config(missingok) /etc/X11/wmconfig/emacs
